/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.bank.message.controller;

import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.bank.checklist.entity.Checklist;
import org.springblade.bank.userlog.entity.UserLog;
import org.springblade.bank.userlog.service.IUserLogService;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.core.tool.utils.Func;
import org.springblade.core.tool.utils.StringUtil;
import org.springblade.modules.desk.entity.Notice;
import org.springblade.modules.desk.service.INoticeService;
import org.springblade.modules.resource.entity.Attach;
import org.springblade.modules.resource.service.IAttachService;
import org.springblade.modules.system.entity.Dept;
import org.springblade.modules.system.entity.User;
import org.springblade.modules.system.service.IDeptService;
import org.springblade.modules.system.service.IUserService;
import org.springframework.util.Assert;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.bank.message.entity.Message;
import org.springblade.bank.message.vo.MessageVO;
import org.springblade.bank.message.wrapper.MessageWrapper;
import org.springblade.bank.message.service.IMessageService;
import org.springblade.core.boot.ctrl.BladeController;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 信息發佈 控制器
 *
 * @author BladeX
 * @since 2021-08-13
 */
@RestController
@AllArgsConstructor
@RequestMapping("bank/message")
@Api(value = "信息發佈", tags = "信息發佈接口")
public class MessageController extends BladeController {

	private final IMessageService messageService;
	private final IAttachService attachService;
	private final IDeptService deptService;
	private final IUserService userService;
	private final IUserLogService userLogService;
	private final INoticeService noticeService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入message")
	public R<MessageVO> detail(Message message) {
		Message detail = messageService.getOne(Condition.getQueryWrapper(message));
		return R.data(MessageWrapper.build().entityVO(detail));
	}

	/**
	 * 分页 信息發佈
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入message")
	public R<IPage<MessageVO>> list(Message message, Query query) {
		IPage<Message> pages = messageService.page(Condition.getPage(query), Condition.getQueryWrapper(message));
		return R.data(MessageWrapper.build().pageVO(pages));
	}


	/**
	 * 自定义分页 信息發佈
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入message")
	public R<IPage<MessageVO>> page(MessageVO message, Query query) {
//		message.setCreateUser(AuthUtil.getUserId());
		message.setCurrentUserId(AuthUtil.getUserId());
		IPage<Message> pages = messageService.selectMessagePage(Condition.getPage(query), message);
		return R.data(MessageWrapper.build().pageVO(pages));
	}

	/**
	 * 新增 信息發佈
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入message")
	public R save(@Valid @RequestBody Message message) {
		return R.status(messageService.save(message));
	}

	/**
	 * 修改 信息發佈
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入message")
	public R update(@Valid @RequestBody Message message) {
		return R.status(messageService.updateById(message));
	}

	/**
	 * 新增或修改 信息發佈
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入message")
	public R submit(@Valid @RequestBody Message message) {
		Attach attach = attachService.getOne(new QueryWrapper<>(new Attach()).lambda().eq(Attach::getLink, message.getFile()));
//		Assert.notNull(attach, "找不到附件");
		if (attach != null){
			message.setName(attach.getName());
			message.setDomain(attach.getDomain());
			message.setOriginalName(attach.getOriginalName());
			message.setExtension(attach.getExtension());
			message.setAttachSize(attach.getAttachSize());
		}

		List<String> deptIds = Func.toStrList(message.getDeptId());
		List<String> roleIds = Func.toStrList(message.getRoleId());
		List<User> userList = userService.getUsersByDeptIdsRoleIds(deptIds, roleIds);
		List<Long> userIdList = userList.stream().map(user -> user.getId()).collect(Collectors.toList());
		String join = StringUtil.join(userIdList);
//		join += "," + AuthUtil.getUserId();
		message.setTargetIds(join);

		boolean isAdd = message.getId() == null;
		BladeUser currentUser = AuthUtil.getUser();
		User user = userService.getById(currentUser.getUserId());
		Dept dept = deptService.getById(user.getDeptId());
		UserLog userLog = new UserLog();
		Message old = null;
		if (isAdd){
//			messageService.save(message);
//			message.setCreateDept(message.getDeptId());
		}else{
			old = messageService.getById(message.getId());
		}

		if (messageService.saveOrUpdate(message)){
			userLog.setTableName("message");
			userLog.setBankNo(dept.getBankNo());
			userLog.setOrgNo(dept.getOrgNo());
			userLog.setOrgName(dept.getDeptName());
			userLog.setNewData(JSONUtil.toJsonStr(message));
			userLog.setPersonNo(user.getEhr());
			userLog.setPersonName(user.getName());

			if (isAdd){
				userLog.setOperationType("add");

				// 發送通知
				noticeService.sendMessageNotice(message, false);
			}else{
				userLog.setOperationType("edit");
				userLog.setOldData(JSONUtil.toJsonStr(old));
				// 發送通知
				noticeService.sendMessageNotice(message, true);
			}
			userLogService.save(userLog);
		}

		return R.status(true);
	}



	/**
	 * 删除 信息發佈
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {

		List<Long> idList = Func.toLongList(ids);
		List<UserLog> userLogList = new ArrayList<>();

		// 日誌記錄
		BladeUser currentUser = AuthUtil.getUser();
		User user = userService.getById(currentUser.getUserId());
		Dept dept = deptService.getById(user.getDeptId());
		idList.forEach(id -> {
			UserLog userLog = new UserLog();
			Message message = messageService.getById(id);
			userLog.setTableName("message");
			userLog.setOperationType("del");
			userLog.setBankNo(dept.getBankNo());
			userLog.setOrgNo(dept.getOrgNo());
			userLog.setOrgName(dept.getDeptName());
			userLog.setOldData(JSONUtil.toJsonStr(message));
			userLog.setPersonNo(user.getEhr());
			userLog.setPersonName(user.getName());
			userLogList.add(userLog);
		});

		return R.status(messageService.deleteLogic(idList) && userLogService.saveBatch(userLogList));
	}


}
